<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "dma".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Dma".
 *
 * Columns in table "dma" available as properties of the model,
 * followed by relations of table "dma" available as properties of the model.
 *
 * @property integer $id
 * @property string $code
 * @property string $name
 * @property integer $country_id
 *
 * @property Country $country
 * @property Location[] $locations
 */
abstract class BaseDma extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'dma';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Dma|Dmas', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('country_id, code, name', 'required'),
            array('country_id', 'numerical', 'integerOnly' => true),
            array('code, name', 'length', 'max' => 50),
            array('code, name', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, code, name, country_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'country' => array(self::BELONGS_TO, 'Country', 'country_id'),
            'locations' => array(self::HAS_MANY, 'Location', 'dma_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'code' => Yii::t('app', 'Code'),
            'name' => Yii::t('app', 'Name'),
            'country_id' => null,
            'country' => null,
            'locations' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('code', $this->code, true);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('country_id', $this->country_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
